' Name des Autopilots
AIName = "Holzchopfs Autopilot"

' Intelligenz des Autopilots
' pRobot ist der Roboter
'	Ihr drft nicht auf die Felder von pRobot zugreifen!
'	pRobot wird lediglich verwendet als Parameter fr die Funktionen
'	GetV1, GetV2, AccelerateRobot und AccelerateRobotTo
' pDists ein Array mit den Distanzen der Sensoren
'	Das Array ist SENSORS_VIS_CNT gross, resp 2 * SENSORS_PER_SIDE + 1
'	Index 0 ist der Sensor, der ganz nach rechts zeigt
'	Index SENSORS_PER_SIDE zeigt geradeaus
'	Index SENSORS_VIS_CNT - 1 zeigt nach links
'	Die Distanz ist in Einheiten angeben (1 Einheit = 1 Tile)
Function AutoPilotRobot(pRobot:TRobot, pDists#[])
	' Gefahr der Kollision?
	Local collisionahead% = False
	Local collisiondirection% = 0
	Local freedirection# = 0
	' Sensor-Daten auswerten
	Local i%, j%
	For j = -SENSORS_PER_SIDE To SENSORS_PER_SIDE
		i = j + SENSORS_PER_SIDE
		' Wie weit muss ein Sensor mindestens sehen, um sicher geradeaus fahren zu drfen?
		Local savedistance# = 0.3 +(0.4 *Cos(j * SENSORS_DIVISION))
		' Wenn's kritisch wird: entgegensteuern
		If pDists[i] < savedistance Then
			collisionahead = True
			collisiondirection = collisiondirection -j
		' Freie Richtung bestimmen
		ElseIf Abs(j) > 6 And pDists[i] > 1.0 Then
			freedirection = freedirection +j *pDists[i]
		EndIf
	Next
	' Steuerung
	Local sw#, fw# '=0.01
	' Kollision droht: abdrehen
	If collisionahead Then
		' Kollision droht geradeaus: in freie Richtung drehen
		If collisiondirection = 0 Then
			sw = Sgn(freedirection) * 0.01
		' Kollision droht auf einer Seite: von Wand wegdrehen
		Else
			sw = Sgn(collisiondirection) * 0.01
		EndIf
	' Freie Fahrt: in bevorzugte Richtung fahren
	Else
		sw = freedirection * 0.01 * MAX_VEL
		fw = MAX_VEL -Abs(sw)
	EndIf
	
	' Steuern
	' Zum Steuern stehen euch diese beiden Funktionen zur Verfgung
	' - AccelerateRobot(pRobot, pAcc1#, pAcc2#)
	'	Beschleunigt die Rder um die angegebenen Werte. Die Beschleunigung wird
	'	von der Simulation beschrnkt auf MAX_ACC, hhere Werte werden begrenzt.
	' - AccelerateRobotTo(pRobot, pVel1#, pVel2#)
	'	Beschleunigt die Rder mit Maximalbeschleunigung auf die angegebenen Ziel-
	'	geschwindigkeiten. Die Geschwindigkeit wird von der Simulation beschrnkt
	'	auf MAX_VEL, hhere Werte werden begrenzt.
	AccelerateRobotTo(pRobot, fw +sw, fw -sw)
End Function