; Hintergrund-Farbe
Const HUD_BG_R%		= 96
Const HUD_BG_G%		= 96
Const HUD_BG_B%		= 96
; Text-Farbe
Const HUD_TEXT_R%	= 255
Const HUD_TEXT_G%	= 255
Const HUD_TEXT_B%	= 255
; Indikator-Farbe
Const HUD_INDICATOR_R%	= 0
Const HUD_INDICATOR_G%	= 240
Const HUD_INDICATOR_B%	= 0

; HUD zeichnen
Function DrawHUD(pSandbox.TSandbox, pFont.TSimpFont)
	; Geschwindigkeits-Indikatoren fr linkes und rechtes Rad
	DrawHUDVelIndicator(pSandbox\robot\v1, -1)
	DrawHUDVelIndicator(pSandbox\robot\v2, TILES_X)
	; Distanz-Indikatoren der Sensoren
	DrawHUDDistIndicator(pSandbox\dists)
	; Info-Texte
	DrawHUDTexts(pSandbox, pFont)
End Function

; Geschwindigkeits-Indikator
Function DrawHUDVelIndicator(pVel#, pX%)
	; Position berechnen
	Local x% = pX * TILE_SIZE
	Local y% = 0
	Local w% = TILE_SIZE
	Local h% = (TILES_Y + HUD_HEIGHT) * TILE_SIZE
	Local h2% = h /2
	; Hintergrund zeichnen
	Color(HUD_BG_R, HUD_BG_G, HUD_BG_B)
	Rect(x+4, y+4, w-8, h-8)
	; Indikator zeichnen
	Color(HUD_INDICATOR_R, HUD_INDICATOR_G, HUD_INDICATOR_B)
	Local y1%, y2%, yh%
	yh = -pVel *(h2 -4) / MAX_VEL
	y1 = y+h2
	y2 = y+h2+yh
	Rect(x+4, Min(y1, y2), w-8, Abs(yh))
End Function

; Distanz-Indikatoren
Function DrawHUDDistIndicator(pDists#[SENSORS_VIS_CNT])
	; Position berechnen
	Local x% = 0
	Local y% = TILES_Y * TILE_SIZE
	Local w% = TILES_X * TILE_SIZE
	Local h% = (HUD_HEIGHT -1) * TILE_SIZE
	; Hintergrund zeichnen
	Color(HUD_BG_R, HUD_BG_G, HUD_BG_B)
	Rect(0, y +4, w, h -8)
	; Indikatoren zeichnen
	Color(HUD_INDICATOR_R, HUD_INDICATOR_G, HUD_INDICATOR_B)
	Local ix%, iy%, iw%, ih%
	iy = y +h -4
	iw = Floor(w /20.0)
	Local i%, j%
	For j = -SENSORS_PER_SIDE To SENSORS_PER_SIDE
		i = j + SENSORS_PER_SIDE
		; Position
		ix = w /2.0 +j *iw
		; hhe, beschrnkt auf HUD-Grsse
		ih = Min(pDists[i] / TILES_X *h *4, h -8)
		Rect(ix -iw /2 +2, iy-ih, iw -4, ih)
	Next
End Function

; Texte
Function DrawHUDTexts(pSandbox.TSandbox, pFont.TSimpFont)
	; Position berechnen
	Local x% = 0
	Local y% = (TILES_Y + HUD_HEIGHT -1) * TILE_SIZE
	Local w% = TILES_X * TILE_SIZE
	Local h% = TILE_SIZE
	; Hintergrund zeichnen
	Color(HUD_BG_R, HUD_BG_G, HUD_BG_B)
	Rect(0, y, w, h -4)
	; Texte zeichnen
	Color(HUD_TEXT_R, HUD_TEXT_G, HUD_TEXT_B)
	; Rundenzahl
	DrawSimpText(pFont, "Runde: "+pSandbox\goal\round, x+w/2, y+2, ALIGN_CENTER)
	; Rundenzeit
	Local time%
	If pSandbox\goal\round = 0 Then
		time = -1
	Else
		time = (gametime -pSandbox\goal\passtime)
	EndIf
	DrawSimpText(pFont, "Zeit: "+FmtTime(time), x+2, y+2)
	DrawSimpText(pFont, "Bestzeit: "+FmtTime(pSandbox\goal\besttime), x+w-2, y+2, ALIGN_RIGHT)
End Function

; Formatiert eine Zeit (Typ gametime) in einen
; String des Formats "m:ss:cc"
Function FmtTime$(pTime%)
	; "undefinierte" Zeit ausgeben
	If pTime < 0 Then
		Return "-:--:--"
	EndIf
	; Zeit-Komponenten berechnen
	Local msecs%	= pTime * LOOPTIME
	Local csecs%	= Floor(msecs /10.0)
	Local secs%		= Floor(msecs /1000.0)
	Local mins%		= Floor(secs /60.0)
	secs	= secs Mod 60
	csecs	= csecs Mod 100
	; Formatierte Zeit ausgeben
	Return mins +":" +Right("0"+secs, 2) +":" +Right("0"+csecs, 2)
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D