; Ziel
Type TGoal
	; Position und Richtung
	Field x%, y%
	Field dir%
	; Wird/wurde das Ziel passiert?
	Field passed%
	; Runden- und Rundenzeitzhler
	Field round%, passtime%, besttime%
End Type
; Ziel erstellen
Function CreateGoal.TGoal()
	Local goal.TGoal = New TGoal
	ResetGoal(goal)
	Return goal
End Function
; Ziel zurcksetzen
Function ResetGoal(pGoal.TGoal)
	pGoal\round		= 0
	pGoal\besttime	= -1
End Function

; Ziel auf berfahrt prfen
Function CheckGoal(pGoal.TGoal, pRobot.TRobot)
	Local ix% = Floor(pRobot\posx)
	Local iy% = Floor(pRobot\posy)
	Local dx# = pRobot\posx -ix
	Local dy# = pRobot\posy -iy
	; Wenn die Figur auf dem Ziel-Tile ist
	If ix = pGoal\x And iy = pGoal\y Then
		; ... und das Ziel nicht schon als passiert markiert ist
		If pGoal\passed = False Then
			; Schauen, ob das Ziel richtig rum durchfahren wird
			Select pGoal\dir
			Case 0
				If dx >= (1 - ROBOT_RADIUS) Then PassGoal(pGoal)
			Case 1
				If dy >= (1 - ROBOT_RADIUS) Then PassGoal(pGoal)
			Case 2
				If dx < ROBOT_RADIUS Then PassGoal(pGoal)
			Case 3
				If dy < ROBOT_RADIUS Then PassGoal(pGoal)
			End Select
		EndIf
	; Nicht auf Ziel-Tile: sicher nicht am passieren
	Else
		pGoal\passed = False
	EndIf
End Function
; Ziel berfahren
Function PassGoal(pGoal.TGoal)
	pGoal\passed = True
	; Rundenzeit aktualisieren
	Local roundtime% = gametime -pGoal\passtime
	pGoal\passtime = gametime
	; Ab 2. Runde: Rundenbestzeit aktualisieren
	If pGoal\round > 0 Then
		If pGoal\besttime = -1 Or roundtime < pGoal\besttime Then
			pGoal\besttime = roundtime
		EndIf
	EndIf
	; Rundenzhler erhhen
	pGoal\round = pGoal\round +1
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D