; Sensor auf dem Roboter
Type TSensor
	; Ort des Sensors
	Field posx#, posy#
	Field angle#
	; Ort der Detektion
	Field hitx#, hity#
	Field dist#
End Type
; Sensor positionieren und ausrichten
Function PositionSensor(pSensor.TSensor, pX#, pY#, pAngle#)
	pSensor\posx = pX
	pSensor\posy = pY
	pSensor\angle = pAngle;(pAngle +360) Mod 360
End Function
; Sensor aktualisieren (fhlen lassen)
Function UpdateSensor(pSensor.TSensor, pSandbox.TSandbox)
	Local ix%, iy%
	ix = Floor(pSensor\posx)
	iy = Floor(pSensor\posy)
	; Sensor sitzt in der Wand: Distanz = 0
	If pSandbox\map[TILES_X *iy +ix] = TILE_WALL Then
		pSensor\hitx = pSensor\posx
		pSensor\hity = pSensor\posy
		pSensor\dist = 0
		Return
	EndIf
	; Wand-Schnittpunkt finden
	Local cval#, sval#, tval#, ctval#
	cval = Cos(pSensor\angle)
	sval = Sin(pSensor\angle)
	tval = Tan(pSensor\angle)
	ctval = 1 /tval
	; Koordinaten des Punktes der geprft wird
	Local px#, py#
	px = pSensor\posx
	py = pSensor\posy
	; Index-weises durch die Kartendaten bewegen
	Local lx%, ly%
	Repeat
		lx = 0
		ly = 0
		; Punkt innerhalb des Tiles
		Local sx#, sy#
		sx = px -ix
		sy = py -iy
		; Koordinaten des Schnittpunkts Sensor-Richtung zu Tile-Kante
		Local cx#, cy#
		; Kante zum nchsten Tile finden
		; Sensor schaut gerade nach oben
		If sval = 1 Then
			cx = 0
			cy = 1 -sy
			ly = 1
		; Sensor schaut gerade nach unten
		ElseIf sval = -1 Then
			cx = 0
			cy = -sy
			ly = -1
		; Sensor schaut nach links oder rechts
		Else
			; Sensor schaut nach rechts
			If cval > 0 Then
				cx = 1 -sx
				cy = tval *cx
				lx = 1
			; Sensor schaut nach links
			ElseIf cval < 0 Then
				cx = -sx
				cy = tval *cx
				lx = -1
			EndIf
			; Sensor-Strahl berhrt obere Tile-Kante
			If (sy+cy) < 0 Then
				cy = -sy
				cx = ctval *cy
				lx = 0
				ly = -1
			; Sensor-Strahl berhrt untere Tile-Kante
			ElseIf (sy+cy) > 1 Then
				cy = 1 -sy
				cx = ctval *cy
				lx = 0
				ly = 1
			EndIf
		EndIf
		; Sensor-Strahl zum nchsten Tile bewegen
		px = px +cx
		py = py +cy
		ix = ix +lx
		iy = iy +ly
		; Detektiert er dort Wand?
		If pSandbox\map[TILES_X *iy +ix] = TILE_WALL Then
			pSensor\hitx = px
			pSensor\hity = py
			; Distanz zwischen Sensor und Detektion
			Local dx#, dy#
			dx = px -pSensor\posx
			dy = py -pSensor\posy
			pSensor\dist = Sqr(dx*dx +dy*dy)
			Return
		EndIf
	Forever
End Function

;~IDEal Editor Parameters:
;~C#Blitz3D