; Mgliche Ausrichtungen der Schrift
Const ALIGN_LEFT%	= 0
Const ALIGN_CENTER%	= 1
Const ALIGN_RIGHT%	= 2
; Image-Font
Type TSimpFont
	; Bild
	Field img%
	; Zeichen-Breiten
	Field widths%[256]
End Type
; Schriftart laden
Function LoadSimpFont.TSimpFont(pFile$, pCellSize%)
	Local fnt.TSimpFont = New TSimpFont
	; Bild laden
	fnt\img = LoadAnimImage(pFile +".png", pCellSize, pCellSize, 0, 256)
	; Zeichenbreiten laden
	Local file% = ReadFile(pFile +".dat")
	Local char%, nstr$, idx%
	While Not Eof(file)
		char = ReadByte(file)
		; Zahl? Zum numerischen String hinzufgen
		If char => 48 And char <= 57 Then
			nstr = nstr +Chr(char)
		; nicht Zahl? ggf. numerischen String als Breite speichern
		ElseIf nstr <> "" Then
			fnt\widths[idx] = Int(nstr)
			nstr = ""
			idx = idx +1
		EndIf
	Wend
	CloseFile(file)
	Return fnt
End Function
; Text mit Schriftart zeichnen
Function DrawSimpText(pFont.TSimpFont, pText$, pX%, pY%, pAlign% = ALIGN_LEFT)
	; Textausrichtung
	If pAlign = ALIGN_CENTER Then
		pX = pX -GetSimpTextWidth(pFont, pText) /2.0
	ElseIf pAlign = ALIGN_RIGHT Then
		pX = pX -GetSimpTextWidth(pFont, pText)
	EndIf
	; Text zeichenweise zeichnen
	Local ln% = Len(pText)
	Local char%
	Local i%
	For i = 1 To ln
		char = Asc(Mid(pText, i, 1))
		DrawImage(pFont\img, pX, pY, char)
		pX = pX +pFont\widths[char] +2
	Next
End Function
; Textbreite fr gegebene Schriftart ermitteln
Function GetSimpTextWidth%(pFont.TSimpFont, pText$)
	; Zwischenraum zwischen zwei Zeichen subtrahieren
	Local w% = -2
	Local ln% = Len(pText)
	Local char%
	Local i%
	; Breiten aufaddieren
	For i = 1 To ln
		char = Asc(Mid(pText, i, 1))
		w = w +pFont\widths[char] +2
	Next
	Return w
End Function

;~IDEal Editor Parameters:
;~C#Blitz3D