; Sources einbinden
Include "_srcbb/MinMax.bb"
Include "_srcbb/consts.bb"
Include "_srcbb/HUD.bb"
Include "_srcbb/Menu.bb"
Include "_srcbb/TGoal.bb"
Include "_srcbb/TRobot.bb"
Include "_srcbb/TSandbox.bb"
Include "_srcbb/TSensor.bb"
Include "_srcbb/TSimpFont.bb"

;*******************************************************************************
; Hier kommt deine AI hin
Include "AIs/holzchopf.bb"
;*******************************************************************************

; Spiel
Global gametime%
Global state%, controls%
Global mx%, my%, mh1%

; Initialisieren
Local timer% = CreateTimer(HERTZ)
Local sandbox.TSandbox = CreateSandbox()
state = STATE_MENU
controls = CONTROLS_AI

Graphics(SCREEN_WIDTH, SCREEN_HEIGHT, 0, 2)
SetBuffer(BackBuffer())

; Medien laden
LoadTiles(sandbox, "gfx/Tiles.png")
LoadMap(sandbox, "map.txt")

Local font.TSimpFont = LoadSimpFont("gfx/font", 32)

Local crosshairs% = LoadImage("gfx/Crosshairs.png")
HandleImage(crosshairs, 200,200)

Origin(HUD_SIDE_WIDTH * TILE_SIZE, 0)

MoveMouse(SCREEN_WIDTH /2, SCREEN_HEIGHT /2)

; Hauptschleife
Local timerruns% = 1
Repeat
	mx = MouseX() - HUD_SIDE_WIDTH * TILE_SIZE
	my = MouseY()
	mh1 = MouseHit(MOUSE_LEFT)
	
	; FSM
	Select state
	Case STATE_SIMULATION
		; synchrone Aktualisierung
		Local r%
		For r = 1 To timerruns
			gametime = gametime +1
			; Steuerung manuell / Autopilot
			If controls = CONTROLS_HUMAN Then
				MousePilotRobot(sandbox\robot)
			Else
				AutoPilotRobot(sandbox\robot, sandbox\dists)
			EndIf
			; Simulation aktualisieren
			UpdateSandbox(sandbox)
		Next
	End Select

	; Ausgabe
	Cls
	
	DrawSandbox(sandbox)
	DrawHUD(sandbox, font)
	
	; Hilfslinien bei manueller Steuerung
	If controls = CONTROLS_HUMAN Then
		DrawImage(crosshairs, SCREEN_WIDTH /2 - HUD_SIDE_WIDTH * TILE_SIZE, 300)
	EndIf
	
	DrawMenu(sandbox, font)
	
	timerruns = WaitTimer(timer)
	Flip 0
Forever

End
;~IDEal Editor Parameters:
;~C#Blitz3D